Index: /trunk/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/IOM/iom.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/IOM/iom.F90	(revision 911)
@@ -6,4 +6,5 @@
    !! History :  9.0  ! 05 12  (J. Belier) Original code
    !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
+   !!             "   ! 07 07  (D. Storkey) Changes to iom_gettime
    !!--------------------------------------------------------------------
    !!gm  caution add !DIR nec: improved performance to be checked as well as no result changes
@@ -646,5 +647,5 @@
 
 
-   SUBROUTINE iom_gettime( kiomid, cdvar, ptime )
+   SUBROUTINE iom_gettime( kiomid, ptime, cdvar, kntime, cdunits, cdcalendar )
       !!--------------------------------------------------------------------
       !!                   ***  SUBROUTINE iom_gettime  ***
@@ -652,15 +653,30 @@
       !! ** Purpose : read the time axis cdvar in the file 
       !!--------------------------------------------------------------------
-      INTEGER               , INTENT(in   ) ::   kiomid   ! file Identifier
-      CHARACTER(len=*)      , INTENT(in   ) ::   cdvar    ! time axis name
-      REAL(wp), DIMENSION(:), INTENT(  out) ::   ptime    ! the time axis
-      !
+      INTEGER                    , INTENT(in   ) ::   kiomid     ! file Identifier
+      REAL(wp), DIMENSION(:)     , INTENT(  out) ::   ptime      ! the time axis
+      CHARACTER(len=*), OPTIONAL , INTENT(in   ) ::   cdvar      ! time axis name
+      INTEGER         , OPTIONAL , INTENT(  out) ::   kntime     ! number of times in file
+      CHARACTER(len=*), OPTIONAL , INTENT(  out) ::   cdunits    ! units attribute of time coordinate
+      CHARACTER(len=*), OPTIONAL , INTENT(  out) ::   cdcalendar ! calendar attribute of 
+      !
+      INTEGER, DIMENSION(1) :: kdimsz
       INTEGER            ::   idvar    ! id of the variable
+      CHARACTER(LEN=32)  ::   tname    ! local name of time coordinate
       CHARACTER(LEN=100) ::   clinfo   ! info character
       !---------------------------------------------------------------------
       !
-      IF( kiomid > 0 ) THEN
-         clinfo = 'iom_gettime, file: '//trim(iom_file(kiomid)%name)//', var: '//trim(cdvar)
-         idvar = iom_varid( kiomid, cdvar )
+      IF ( PRESENT(cdvar) ) THEN
+         tname = cdvar
+      ELSE
+         tname = iom_file(kiomid)%uldname
+      ENDIF
+      IF( kiomid > 0 ) THEN
+         clinfo = 'iom_gettime, file: '//trim(iom_file(kiomid)%name)//', var: '//trim(tname)
+         IF ( PRESENT(kntime) ) THEN
+            idvar  = iom_varid( kiomid, tname, kdimsz = kdimsz )
+            kntime = kdimsz(1)
+         ELSE
+            idvar = iom_varid( kiomid, tname )
+         ENDIF
          !
          ptime(:) = 0. ! default definition
@@ -670,6 +686,6 @@
                   IF( iom_file(kiomid)%dimsz(1,idvar) == size(ptime) ) THEN
                      SELECT CASE (iom_file(kiomid)%iolib)
-                     CASE (jpioipsl )   ;   CALL iom_ioipsl_gettime( kiomid, idvar, ptime )
-                     CASE (jpnf90   )   ;   CALL iom_nf90_gettime(   kiomid, idvar, ptime )
+                     CASE (jpioipsl )   ;   CALL iom_ioipsl_gettime( kiomid, idvar, ptime, cdunits, cdcalendar )
+                     CASE (jpnf90   )   ;   CALL iom_nf90_gettime(   kiomid, idvar, ptime, cdunits, cdcalendar )
                      CASE (jprstdimg)   ;   CALL ctl_stop( TRIM(clinfo)//' case IO library == jprstdimg not coded...' )
                      CASE DEFAULT    
Index: /trunk/NEMO/OPA_SRC/IOM/iom_def.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/IOM/iom_def.F90	(revision 911)
@@ -5,4 +5,5 @@
    !!====================================================================
    !! History :  9.0  ! 06 09  (S. Masson) Original code
+   !!             "   ! 07 07  (D. Storkey) Add uldname
    !!--------------------------------------------------------------------
    !!---------------------------------------------------------------------------------
@@ -57,4 +58,5 @@
       INTEGER                                   ::   iduld    !: id of the unlimited dimension
       INTEGER                                   ::   irec     !: writing record position  
+      CHARACTER(LEN=32)                         ::   uldname  !: name of the unlimited dimension
       CHARACTER(LEN=32), DIMENSION(jpmax_vars)  ::   cn_var   !: names of the variables
       INTEGER, DIMENSION(jpmax_vars)            ::   nvid     !: id of the variables
Index: /trunk/NEMO/OPA_SRC/IOM/iom_ioipsl.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/IOM/iom_ioipsl.F90	(revision 911)
@@ -6,4 +6,5 @@
    !! History :  9.0  ! 05 12  (J. Belier) Original code
    !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
+   !!             "   ! 07 07  (D. Storkey) Changes to iom_ioipsl_gettime
    !!--------------------------------------------------------------------
    !!gm  caution add !DIR nec: improved performance to be checked as well as no result changes
@@ -254,5 +255,5 @@
 
 
-   SUBROUTINE iom_ioipsl_gettime( kiomid, kvid, ptime )
+   SUBROUTINE iom_ioipsl_gettime( kiomid, kvid, ptime, cdunits, cdcalendar )
       !!--------------------------------------------------------------------
       !!                   ***  SUBROUTINE iom_gettime  ***
@@ -260,11 +261,19 @@
       !! ** Purpose : read the time axis kvid in the file with IOIPSL (only fliocom module)
       !!--------------------------------------------------------------------
-      INTEGER               , INTENT(in   ) ::   kiomid   ! file Identifier
-      INTEGER               , INTENT(in   ) ::   kvid     ! variable id
-      REAL(wp), DIMENSION(:), INTENT(  out) ::   ptime    ! the time axis
+      INTEGER                   , INTENT(in   ) ::   kiomid     ! file Identifier
+      INTEGER                   , INTENT(in   ) ::   kvid       ! variable id
+      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   ptime      ! the time axis
+      CHARACTER(len=*), OPTIONAL, INTENT(  out) ::   cdunits    ! units attribute
+      CHARACTER(len=*), OPTIONAL, INTENT(  out) ::   cdcalendar ! calendar attribute
       !---------------------------------------------------------------------
       !
       CALL fliogetv( iom_file(kiomid)%nfid, TRIM(iom_file(kiomid)%cn_var(kvid)), ptime(:),   &
             &         start=(/ 1 /), count=(/ iom_file(kiomid)%dimsz(1, kvid) /) )
+      IF ( PRESENT(cdunits) ) THEN 
+         CALL fliogeta( iom_file(kiomid)%nfid, TRIM(iom_file(kiomid)%cn_var(kvid)), "units", cdunits )
+      ENDIF
+      IF ( PRESENT(cdcalendar) ) THEN 
+         CALL fliogeta( iom_file(kiomid)%nfid, TRIM(iom_file(kiomid)%cn_var(kvid)), "calendar", cdcalendar )
+      ENDIF
       !
    END SUBROUTINE iom_ioipsl_gettime
Index: /trunk/NEMO/OPA_SRC/IOM/iom_nf90.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/IOM/iom_nf90.F90	(revision 911)
@@ -6,4 +6,5 @@
    !! History :  9.0  ! 05 12  (J. Belier) Original code
    !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
+   !!             "   ! 07 07  (D. Storkey) Changes to iom_nf90_gettime
    !!--------------------------------------------------------------------
    !!gm  caution add !DIR nec: improved performance to be checked as well as no result changes
@@ -121,4 +122,8 @@
          iom_file(kiomid)%irec   = -1   ! useless for NetCDF files, used to know if the file is in define mode 
          CALL iom_nf90_check(NF90_Inquire(if90id, unlimitedDimId = iom_file(kiomid)%iduld), clinfo)
+         IF ( iom_file(kiomid)%iduld .GE. 0 ) THEN
+           CALL iom_nf90_check(NF90_Inquire_Dimension(if90id, iom_file(kiomid)%iduld,   &
+        &                                               name = iom_file(kiomid)%uldname), clinfo)
+         ENDIF
          IF(lwp) WRITE(numout,*) '                   ---> '//TRIM(cdname)//' OK'
       ELSE
@@ -272,5 +277,5 @@
 
 
-   SUBROUTINE iom_nf90_gettime( kiomid, kvid, ptime )
+   SUBROUTINE iom_nf90_gettime( kiomid, kvid, ptime, cdunits, cdcalendar )
       !!--------------------------------------------------------------------
       !!                   ***  SUBROUTINE iom_gettime  ***
@@ -278,7 +283,9 @@
       !! ** Purpose : read the time axis kvid in the file with NF90
       !!--------------------------------------------------------------------
-      INTEGER               , INTENT(in   ) ::   kiomid   ! file Identifier
-      INTEGER               , INTENT(in   ) ::   kvid     ! variable id
-      REAL(wp), DIMENSION(:), INTENT(  out) ::   ptime    ! the time axis
+      INTEGER                   , INTENT(in   ) ::   kiomid     ! file Identifier
+      INTEGER                   , INTENT(in   ) ::   kvid       ! variable id
+      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   ptime      ! the time axis
+      CHARACTER(len=*), OPTIONAL, INTENT(  out) ::   cdunits    ! units attribute
+      CHARACTER(len=*), OPTIONAL, INTENT(  out) ::   cdcalendar ! calendar attribute
       !
       CHARACTER(LEN=100) ::   clinfo     ! info character
@@ -287,4 +294,12 @@
       CALL iom_nf90_check(NF90_GET_VAR(iom_file(kiomid)%nfid, iom_file(kiomid)%nvid(kvid), ptime(:),   &
             &                           start=(/ 1 /), count=(/ iom_file(kiomid)%dimsz(1, kvid) /)), clinfo)
+      IF ( PRESENT(cdunits) ) THEN 
+         CALL iom_nf90_check(NF90_GET_ATT(iom_file(kiomid)%nfid, iom_file(kiomid)%nvid(kvid), "units", &
+            &                           values=cdunits), clinfo)
+      ENDIF
+      IF ( PRESENT(cdcalendar) ) THEN 
+         CALL iom_nf90_check(NF90_GET_ATT(iom_file(kiomid)%nfid, iom_file(kiomid)%nvid(kvid), "calendar", &
+            &                           values=cdcalendar), clinfo)
+      ENDIF
       !
    END SUBROUTINE iom_nf90_gettime
Index: /trunk/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 911)
@@ -8,4 +8,5 @@
    !!   8.5  !  02-10 (C. Talandier, A-M. Treguier) Free surface, F90
    !!   9.0  !  04-06 (F. Durand, A-M. Treguier) Netcdf BC files on input
+   !!    "   ! 07-07  (D. Storkey) Change to arguments for iom_gettime
    !!------------------------------------------------------------------------------
 #if defined key_obc
@@ -159,5 +160,5 @@
                IF ( lp_obc_east ) THEN
                   IF ( llnot_done ) THEN
-                     CALL iom_gettime ( id_e, TRIM(cl_vname), tcobc )
+                     CALL iom_gettime ( id_e, tcobc, TRIM(cl_vname) )
                      llnot_done = .FALSE.
                   ENDIF
@@ -166,5 +167,5 @@
                IF ( lp_obc_west ) THEN
                   IF ( llnot_done ) THEN
-                     CALL iom_gettime ( id_w, TRIM(cl_vname), tcobc )
+                     CALL iom_gettime ( id_w, tcobc, TRIM(cl_vname) )
                      llnot_done = .FALSE.
                  ENDIF
@@ -173,5 +174,5 @@
                IF ( lp_obc_north ) THEN
                   IF ( llnot_done ) THEN
-                     CALL iom_gettime ( id_n, TRIM(cl_vname), tcobc )
+                     CALL iom_gettime ( id_n, tcobc, TRIM(cl_vname) )
                      llnot_done = .FALSE.
                   ENDIF
@@ -180,5 +181,5 @@
                IF ( lp_obc_south ) THEN
                   IF ( llnot_done ) THEN
-                     CALL iom_gettime ( id_s, TRIM(cl_vname), tcobc )
+                     CALL iom_gettime ( id_s, tcobc, TRIM(cl_vname) )
                      llnot_done = .FALSE.
                   ENDIF
Index: /trunk/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 911)
@@ -27,4 +27,5 @@
    USE domvvl          ! variable volume
    USE obctra          ! open boundary condition (obc_tra routine)
+   USE bdytra          ! Unstructured open boundary condition (bdy_tra routine)
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -159,4 +160,16 @@
       ! Update tracers on open boundaries.
       CALL obc_tra( kt )
+
+      !                                                ! ===============
+      DO jk = 1, jpkm1                                 ! Horizontal slab
+         !                                             ! ===============
+#elif defined key_bdy
+         !                                             ! ===============
+      END DO                                           !   End of slab
+      !                                                ! ===============
+
+      ! Update tracers on open boundaries.
+      CALL bdy_tra( kt )
+
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
Index: /trunk/NEMO/OPA_SRC/opa.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/opa.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/opa.F90	(revision 911)
@@ -34,4 +34,5 @@
    !!    "   !  06-03  (L. Debreu, C. Mazauric)  Agrif implementation
    !!    "   !  06-04  (G. Madec, R. Benshila)  Step reorganization
+   !!    "   !  07-07  (J. Chanut, A. Sellar) Unstructured open boundaries (BDY)
    !!----------------------------------------------------------------------
    !! * Modules used
@@ -50,4 +51,7 @@
    USE obc_par         ! open boundary cond. parameters
    USE obcini          ! open boundary cond. initialization (obc_ini routine)
+   USE bdy_par         ! unstructured open boundary cond. parameters
+   USE bdyini          ! unstructured open boundary cond. initialization (bdy_init routine)
+   USE bdytides        ! tides at open boundaries initialization (lk_bdy_tides)
    USE istate          ! initial state setting          (istate_init routine)
    USE eosbn2          ! equation of state            (eos bn2 routine)
@@ -269,4 +273,7 @@
       IF( lk_obc    )   CALL obc_init       ! Open boundaries 
 
+      IF( lk_bdy .OR. lk_bdy_tides )   &
+         &              CALL bdy_init       ! Unstructured open boundaries
+
       CALL istate_init                      ! ocean initial state (Dynamics and tracers)
 
Index: /trunk/NEMO/OPA_SRC/step.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/step.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/step.F90	(revision 911)
@@ -20,4 +20,5 @@
    !!             " "  !  06-07  (S. Masson)  restart using iom
    !!             " "  !  06-08  (G. Madec)  surface module 
+   !!             " "  !  07-07  (J. Chanut, A. Sellar) Unstructured open boundaries (BDY)
    !!----------------------------------------------------------------------
 
@@ -74,4 +75,7 @@
    USE obcrad          ! open boundary cond. radiation    (obc_rad routine)
    USE obcspg          ! open boundary cond  spg          (obc_spg routine)
+
+   USE bdy_par         ! unstructured open boundary data variables
+   USE bdydta          ! unstructured open boundary data  (bdy_dta routine)
 
    USE divcur          ! hor. divergence and curl      (div & cur routines)
@@ -187,4 +191,6 @@
       IF( lk_obc     )   CALL obc_rad( kstp )         ! compute phase velocities at open boundaries
 
+      IF( lk_bdy     )   CALL bdy_dta( kstp )         ! update dynamic and tracer data at unstructured open boundary
+
       IF( ninist == 1 ) THEN                       ! Output the initial state and forcings
                         CALL dia_wri_state( 'output.init' )
